---
title: '<style>: The Style Information element'
slug: Web/HTML/Element/style
tags:
  - CSS
  - Element
  - HTML
  - HTML document metadata
  - Reference
  - Style
  - Web
---
<div>{{HTMLRef}}</div>

<p><span class="seoSummary">The <strong>HTML <code>&lt;style&gt;</code> element</strong> contains style information for a document, or part of a document.</span> It contains CSS, which is applied to the contents of the document containing the <code>&lt;style&gt;</code> element.</p>

<div>{{EmbedInteractiveExample("pages/tabbed/style.html", "tabbed-standard")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<p>The <code>&lt;style&gt;</code> element must be included inside the {{htmlelement("head")}} of the document. In general, it is better to put your styles in external stylesheets and apply them using {{htmlelement("link")}} elements.</p>

<p>If you include multiple <code>&lt;style&gt;</code> and <code>&lt;link&gt;</code> elements in your document, they will be applied to the DOM in the order they are included in the document — make sure you include them in the correct order, to avoid unexpected cascade issues.</p>

<p>In the same manner as <code>&lt;link&gt;</code> elements, <code>&lt;style&gt;</code> elements can include <code>media</code> attributes that contain <a href="/en-US/docs/Web/CSS/Media_Queries">media queries</a>, allowing you to selectively apply internal stylesheets to your document depending on media features such as viewport width.</p>

<h2 id="Attributes">Attributes</h2>

<p>This element includes the <a href="/en-US/docs/Web/HTML/Global_attributes">global attributes</a>.</p>

<dl>
 <dt>{{htmlattrdef("type")}}</dt>
 <dd>This attribute defines the styling language as a MIME type (charset should not be specified). This attribute is optional and defaults to <code>text/css</code> if it is not specified; values other than the empty string or <code>text/css</code> are not used. <strong>Note:</strong> There is very little reason to include this attribute in modern web documents.</dd>
 <dt>{{htmlattrdef("media")}}</dt>
 <dd>This attribute defines which media the style should be applied to. Its value is a <a href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries">media query</a>, which defaults to <code>all</code> if the attribute is missing.</dd>
 <dt>{{htmlattrdef("nonce")}}</dt>
 <dd>A cryptographic nonce (number used once) used to whitelist inline styles in a <a href="/en-US/docs/Web/HTTP/Headers/Content-Security-Policy/style-src">style-src Content-Security-Policy</a>. The server must generate a unique nonce value each time it transmits a policy. It is critical to provide a nonce that cannot be guessed as bypassing a resource’s policy is otherwise trivial.</dd>
 <dt>{{htmlattrdef("title")}}</dt>
 <dd>This attribute specifies <a href="/en-US/docs/Web/CSS/Alternative_style_sheets">alternative style sheet</a> sets.</dd>
</dl>

<h3 id="Deprecated_attributes">Deprecated attributes</h3>

<dl>
 <dt>{{htmlattrdef("scoped")}} {{non-standard_inline}} {{deprecated_inline}}</dt>
 <dd>
 <p>This attribute specifies that the styles only apply to the elements of its parent(s) and children.</p>

 <div class="note">
 <p>This attribute may be re-introduced in the future per <a href="https://github.com/w3c/csswg-drafts/issues/3547">https://github.com/w3c/csswg-drafts/issues/3547</a>. If you want to use the attribute now, you can use a <a href="https://github.com/samthor/scoped">polyfill</a>.</p>
 </div>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="A_simple_stylesheet">A simple stylesheet</h3>

<p>In the following example, we apply a very simple stylesheet to a document:</p>

<pre class="brush:html">&lt;!doctype html&gt;
&lt;html&gt;
&lt;head&gt;
  &lt;style&gt;
    p {
      color: red;
    }
  &lt;/style&gt;
&lt;/head&gt;
&lt;body&gt;
  &lt;p&gt;This is my paragraph.&lt;/p&gt;
&lt;/body&gt;
&lt;/html&gt;</pre>

<p>{{EmbedLiveSample('A_simple_stylesheet', '100%', '60')}}</p>

<h3 id="Multiple_style_elements">Multiple style elements</h3>

<p>In this example we've included two <code>&lt;style&gt;</code> elements — notice how the conflicting declarations in the later <code>&lt;style&gt;</code> element override those in the earlier one, if they have equal <a href="/en-US/docs/Web/CSS/Specificity">specificity</a>.</p>

<pre class="brush:html">&lt;!doctype html&gt;
&lt;html&gt;
&lt;head&gt;
  &lt;style&gt;
    p {
      color: white;
      background-color: blue;
      padding: 5px;
      border: 1px solid black;
    }
  &lt;/style&gt;
  &lt;style&gt;
    p {
      color: blue;
      background-color: yellow;
    }
  &lt;/style&gt;
&lt;/head&gt;
&lt;body&gt;
  &lt;p&gt;This is my paragraph.&lt;/p&gt;
&lt;/body&gt;
&lt;/html&gt;</pre>

<p>{{EmbedLiveSample('Multiple_style_elements', '100%', '60')}}</p>

<h3 id="Including_a_media_query">Including a media query</h3>

<p>In this example we build on the previous one, including a <code>media</code> attribute on the second <code>&lt;style&gt;</code> element so it is only applied when the viewport is less than 500px in width.</p>

<pre class="brush:html">&lt;!doctype html&gt;
&lt;html&gt;
&lt;head&gt;
  &lt;style&gt;
    p {
      color: white;
      background-color: blue;
      padding: 5px;
      border: 1px solid black;
    }
  &lt;/style&gt;
  &lt;style media="all and (max-width: 500px)"&gt;
    p {
      color: blue;
      background-color: yellow;
    }
  &lt;/style&gt;
&lt;/head&gt;
&lt;body&gt;
  &lt;p&gt;This is my paragraph.&lt;/p&gt;
&lt;/body&gt;
&lt;/html&gt;</pre>

<p>{{EmbedLiveSample('Including_a_media_query', '100%', '60')}}</p>

<h2 id="Technical_summary">Technical summary</h2>

<table class="properties">
 <tbody>
  <tr>
   <th><a href="/en-US/docs/Web/Guide/HTML/Content_categories">Content categories</a></th>
   <td><a href="/en-US/docs/Web/Guide/HTML/Content_categories#Metadata_content">Metadata content</a>, and if the <code>scoped</code> attribute is present: <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Flow_content">flow content</a>.</td>
  </tr>
  <tr>
   <th>Permitted content</th>
   <td>Text content matching the <code>type</code> attribute, that is <code>text/css</code>.</td>
  </tr>
  <tr>
   <th>Tag omission</th>
   <td>Neither tag is omissible.</td>
  </tr>
  <tr>
   <th>Permitted parents</th>
   <td>Any element that accepts <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Metadata_content">metadata content</a>.</td>
  </tr>
  <tr>
   <th scope="row">Implicit ARIA role</th>
   <td><a href="https://www.w3.org/TR/html-aria/#dfn-no-corresponding-role">No corresponding role</a></td>
  </tr>
  <tr>
   <th scope="row">Permitted ARIA roles</th>
   <td>No <code>role</code> permitted</td>
  </tr>
  <tr>
   <th>DOM interface</th>
   <td>{{domxref("HTMLStyleElement")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{ SpecName('HTML WHATWG', 'semantics.html#the-style-element', 'style') }}</td>
   <td>{{ Spec2('HTML WHATWG') }}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{ SpecName('HTML5 W3C', 'document-metadata.html#the-style-element', 'style') }}</td>
   <td>{{ Spec2('HTML5 W3C') }}</td>
   <td>The <code>type</code> attribute becomes optional.</td>
  </tr>
  <tr>
   <td>{{ SpecName('HTML4.01', 'present/styles.html#h-14.2.3', 'style') }}</td>
   <td>{{ Spec2('HTML4.01') }}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.style")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{HTMLElement("link")}} element, which allows us to apply external stylesheets to a document.</li>
 <li><a href="/en-US/docs/Web/CSS/Alternative_style_sheets">Alternative Style Sheets</a></li>
</ul>
